"""
this file contains the Lexer that is used in parsing Grammar specifications
"""

from PyLR import Lexer
import re


class GrammarLex(Lexer.Lexer):
    
    ID = r"[a-zA-Z_][a-zA-Z_0-9]*"
    COLON = r":"
    SCOLON = r";"
    NL = r"\n"
    WS = r"\s+"
    OR = r"\|"
    LPAREN = r"\("
    RPAREN = r"\)"
    GDEL = r'"""'
    LEX = r"_lex\s+(?P<lex>[^\n]*)"
    CODE = r"_code\s+(?P<code>[^\n]*)"
    CLASS = r"_class\s+(?P<class>[a-zA-Z_][a-zA-Z_0-9]*)"
    COMMENT = r"^\s*#[^\n]*"

    
    def __init__(self):
	Lexer.Lexer.__init__(self)
	self.addpat(self.LEX, "LEX", self.retlex)
	self.addpat(self.CODE, "CODE", self.retcode)
	self.addpat(self.CLASS, "CLASS", self.retclass)
	prgtoks =  [(self.ID, "ID"), 
		    (self.COLON, "COLON"),
		    (self.SCOLON, "SCOLON"),
		    (self.OR, "OR"),
		    (self.LPAREN, "LPAREN"),
		    (self.RPAREN, "RPAREN"),
		    (self.GDEL, "GDEL")]
	for (prg, tok) in prgtoks:
	    self.addpat(prg, tok)
	self.addpat(self.COMMENT, "", None, Lexer.SKIPTOK)
	self.addpat(self.WS, "", None, Lexer.SKIPTOK)	
	self.compile()
	self.lineno = 1

    def retlex(self, mo):
	return mo.group("lex")

    def retcode(self, mo):
	return mo.group("code")
    
    def retclass(self, mo):
	return mo.group("class")


	
